#include "sign.h"

int r_sign_init(struct r_sign_t *sig)
{
	sig->count = 0;
	INIT_LIST_HEAD(&(sig->items));
}

int r_sign_set(struct r_sign_item_t *sig, const char *key, const char *value)
{
	if (!strcmp(key, "name")) {
		strncpy(sig->name, value, sizeof(sig->name));
	} else
	if (!strcmp(key, "size")) {
		sig->size = atoi(value);
	} else
	if (!strcmp(key, "cksum")) {
		sscanf(value, "%x", &sig->csum);
	} 
//	fprintf(stderr, "%s:%s\n", key, value);
}

int r_sign_option(struct r_sign_t *sig, const char *option)
{
	/* set options here */
}

/* returns a freshly new rsign */
struct r_sign_item_t *r_sign_add(struct r_sign_t *sig)
{
	struct r_sign_item_t *r;
	sig->count ++;
	r = (struct r_sign_item_t *)malloc(sizeof(struct r_sign_item_t));
	memset(r, '\0', sizeof(struct r_sign_item_t));
	list_add_tail(&(r->list), &(sig->items));
	return r;
}

int r_sign_load_file(struct r_sign_t *sig, const char *file)
{
	int n;
	FILE *fd;
	char buf[1024];
	char *ptr;
	struct r_sign_item_t *cursig = r_sign_add(sig);

	fd = fopen(file, "r");
	if (fd == NULL) {
		fprintf(stderr, "Cannot open signature file.\n");
		return 0;
	}
	n = 0;
	while(!feof(fd)) {
		buf[0]='\0';
		fgets(buf, 1023, fd);
		if (buf[0]=='-') {
			/* next item */
			cursig = r_sign_add(sig);
			continue;
		}
		ptr = strchr(buf, ':');
		if (ptr) {
			*ptr = '\0';
			ptr = ptr+1;
			ptr[strlen(ptr)-1]='\0';
			r_sign_set(cursig, buf, ptr+1);
		}
	}
	fclose(fd);
	return n;
}

int r_sign_info(struct r_sign_t *sig)
{
	printf("Loaded %d signatures\n", sig->count);
}

int r_sign_free(struct r_sign_t *sig)
{
	struct list_head *pos;
	//list_for_each_safe(pos, n, head) {
	// TODO
	//}
}

int r_sign_check(struct r_sign_t *sig, const char *binfile)
{
	if (binfile==NULL) {
		fprintf(stderr, "No file specified\n");
		return 0;
	}
	fprintf(stderr, "Checking loaded signatures against '%s'\n", binfile);
}

int r_sign_generate(struct r_sign_t *sig, const char *file, FILE *fd)
{
	fprintf(stderr, "Generating signature file for '%s'\n" , file);
}
